function Create(self)
	self.burstTimer = Timer();
	self.burst = false;
	self.canBurst = true;

     local actor = MovableMan:GetMOFromID(self.RootID);
     if MovableMan:IsActor(actor) then
	self.parent = ToActor(actor);
	self.origname = self.parent.PresetName;
     end


			self.Key = CreateAEmitter("Lawgiver Affirmative Check")
			MovableMan:AddParticle(self.Key);
			self.Key.Pos = self.Pos
			self.Key.PinStrength = 1000

	self.recoil = 0;
 
	self.ff = false;
 
	self.f0 = ToMagazine(self.Magazine).RoundCount;
 
	self.f1 = ToMagazine(self.Magazine).RoundCount;

	self.firecounter = 0;
	self.recoilcooldown = 0.00019;
	
	self.destructtimer = Timer();
	self.destruct = false;

end



function Update(self)

if self:IsAtRest() then
	self.parent = nil;
end

--RECOIL CLEAROUT
if self:IsReloading() then
	self.recoil = 0.0;
     local actor = MovableMan:GetMOFromID(self.RootID);
     if MovableMan:IsActor(actor) then
	self.parent = ToActor(actor);
     end

end


--SELF DESTRUCT SWITCH
if self.parent and not(self.parent:IsDead()) then

  if self.parent.PresetName ~= self.origname and self.destruct == false then
	self.destruct = true;
			self.fail = CreateAEmitter("Lawgiver Failed Check")
			MovableMan:AddParticle(self.fail);
			self.fail.Pos = self.Pos
			self.fail.PinStrength = 1000
	self.destructtimer:Reset();
  end

--EXPLODE
  if self.destruct == true and self.destructtimer:IsPastSimMS(750) then
			self.explosion = CreateAEmitter("Lawgiver Explosion")
			MovableMan:AddParticle(self.explosion);
			self.explosion.Pos = self.Pos
			self.explosion.PinStrength = 1000
			self:GibThis();
  end


--LASERS

local vect = Vector(800,0);
local rayL = 0;

	vect = vect:RadRotate(self.parent:GetAimAngle(true));
	vect = vect:SetMagnitude(800);
	rayL = SceneMan:CastObstacleRay(Vector(self.Pos.X,self.Pos.Y-5),vect,vect,vect,self.ID,self.Team,0,3);

	if rayL>0 then
		local part = CreateMOPixel("PTrail");
		part.Pos = SceneMan:GetLastRayHitPos();
		MovableMan:AddParticle(part);
	end

end


--BURST/
--RECOIL ADDUP

if self.Magazine ~= nil then
 
	if self.canBurst == true and self:IsActivated() and self.Magazine.PresetName == "Lawgiver Standard Mag" and self.Magazine ~= nil and self.Magazine.RoundCount > 0 then
		self.burstTimer:Reset();
		self.canBurst = false;
		self.burst = true;
	end

	if self.burst == true then
		if self.burstTimer:IsPastSimMS(100) then
			self.burstTimer:Reset();
			self:Deactivate();
			self.burst = false;
		else
			self:Activate();
		end
	else
		if self.canBurst == false then
			self:Deactivate();
			if self.burstTimer:IsPastSimMS(200) then
				self.canBurst = true;
			end
		end
	end



	if self.ff then
	 
		self.f0 = ToMagazine(self.Magazine).RoundCount;
	 
		self.ff = false;
 
	else
	 
		self.f1 = ToMagazine(self.Magazine).RoundCount;
	 
		self.ff = true;
 
	end

 
  if self:IsActivated() and self.f1 ~= self.f0 then

	if not self.parent then
    	  local actor = MovableMan:GetMOFromID(self.RootID);
    	  if MovableMan:IsActor(actor) then
		self.parent = ToActor(actor);
 	  end

	else

		local recoil2 = self.recoil;
		if recoil2 < 0.024 then
			self.recoil = recoil2 + 0.0007 + (4 - self.parent.Sharpness) * 0.65 * 0.0005;
		end


	end
  end


		local randb = math.random(-4,4);


		local recoil = self.recoil
		local recoilrand = randb * recoil;

		self.RotAngle = self.RotAngle + recoilrand;

  if not self:IsActivated() then
	if recoil > 0 then
		self.recoil = recoil - self.recoilcooldown;

	elseif recoil < 0 then
		self.recoil = 0;
	end

  end

end




end 